from typing import Any

import jijmodeling as jm

from jijmodeling.sampleset import Evaluation, MeasuringTime, Record

from jijzept.response.base import BaseResponse


class JijModelingResponse(BaseResponse, jm.SampleSet):
    @classmethod
    def from_json_obj(cls, json_obj) -> Any:
        response = cls.from_serializable(json_obj)
        return response

    @classmethod
    def empty_data(cls) -> Any:
        return cls(
            record=Record({"x": []}, [0]),
            evaluation=Evaluation([]),
            measuring_time=MeasuringTime(),
        )

    def __repr__(self):
        return jm.SampleSet.__repr__(self)

    def __str__(self):
        return BaseResponse.__repr__(self) + "\n" + jm.SampleSet.__str__(self)
